package info.aspirecn.iov.sjjh.supplier10000039.util;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;

public class DateUtil {
	/**
	  * 日期格式转换yyyy-MM-dd'T'HH:mm:ss.SSSXXX  (yyyy-MM-dd'T'HH:mm:ss.SSSZ) TO  yyyy-MM-dd HH:mm:ss
	  * @throws ParseException
	  */
	 public static String dealDateFormat(String oldDate) {
        Date date1 = null;
        DateFormat df2 = null;
        try {
            DateFormat df = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
            Date date = df.parse(oldDate);
            SimpleDateFormat df1 = new SimpleDateFormat ("EEE MMM dd HH:mm:ss Z yyyy", Locale.UK);
            date1 = df1.parse(date.toString());
            df2 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return df2.format(date1);
	 }
	 
		//计算指定时间前一小时
	 public static  String  starTime(String dateTime) throws Exception  {
	        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	        Calendar calendar = Calendar.getInstance();
	        Date date = sdf.parse(dateTime);
	        calendar.setTime(date);
	        calendar.set(Calendar.HOUR_OF_DAY,calendar.get(Calendar.HOUR_OF_DAY) - 2);
			return sdf.format(calendar.getTime());
		}
		//计算指定时间后一小时
	 public static String  endTime(String dateTime) throws Exception  {
	        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	        Calendar calendar = Calendar.getInstance();
	        Date date = sdf.parse(dateTime);
	        calendar.setTime(date);
	        calendar.set(Calendar.HOUR_OF_DAY,calendar.get(Calendar.HOUR_OF_DAY) + 2);
			return sdf.format(calendar.getTime());
		}
		
		/**
		* 判断当前时间是否在[startTime, endTime]区间，注意时间格式要一致
		*
		* @param nowTime 当前时间
		* @param startTime 开始时间
		* @param endTime 结束时间
		* @return
		* @author jqlin
		*/
		public static boolean isEffectiveDate(Date nowTime, Date startTime, Date endTime) {
			if (nowTime.getTime() == startTime.getTime()|| nowTime.getTime() == endTime.getTime()) {
				return true;
			}
			Calendar date = Calendar.getInstance();
			date.setTime(nowTime);
			Calendar begin = Calendar.getInstance();
			begin.setTime(startTime);
			Calendar end = Calendar.getInstance();
			end.setTime(endTime);
			if (date.after(begin) && date.before(end)) {
				return true;
			} else {
				return false;
			}
		}
	 
	 public static void main(String[] args) throws ParseException {
		
		try {
			 System.out.println(dealDateFormat("2020-04-16T12:40:45.800+0800"));
			 System.out.println(starTime("2020-04-16 12:40:45"));
			 System.out.println(endTime("2020-04-16 12:40:45"));
			 DateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss"); 
			 System.out.println(isEffectiveDate(new Date(),format.parse(starTime("2020-04-17 00:40:45")),format.parse(endTime("2020-04-17 02:40:45"))));
		} catch (Exception e) {
			// TODO: handle exception
		}
	}
}
